---
title: PaymentAddress
slug: Web/API/PaymentAddress
tags:
  - API
  - Interface
  - Payment Request
  - Payment Request API
  - PaymentRequest
  - Reference
  - paymentAddress
---
<div>{{APIRef("Payment Request API")}}{{SecureContext_Header}}</div>

<p><span class="seoSummary">The <strong><code>PaymentAddress</code></strong> interface of the <a href="/en-US/docs/Web/API/Payment_Request_API">Payment Request API</a> is used to store shipping or payment address information.</span></p>

<p>It may be useful to refer to the Universal Postal Union web site's <a href="http://www.upu.int/en/activities/addressing/s42-standard.html">Addressing S42 standard</a> materials, which provide information about international standards for postal addresses.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref('PaymentAddress.addressLine')}} {{readonlyinline}}</dt>
 <dd>An array of {{domxref("DOMString")}} objects providing each line of the address not included among the other properties. The exact size and content varies by country or location and can include, for example, a street name, house number, apartment number, rural delivery route, descriptive instructions, or post office box number.</dd>
 <dt>{{domxref('PaymentAddress.country')}} {{readonlyinline}} </dt>
 <dd>A {{domxref("DOMString")}} specifying the country in which the address is located, using the {{interwiki("wikipedia", "ISO-3166-1 alpha-2")}} standard. The string is always given in its canonical upper-case form. Some examples of valid <code>country</code> values: <code>"US"</code>, <code>"GB"</code>, <code>"CN"</code>, or <code>"JP"</code>.</dd>
 <dt>{{domxref('PaymentAddress.city')}} {{readonlyinline}}</dt>
 <dd>A {{domxref("DOMString")}} which contains the city or town portion of the address.</dd>
 <dt>{{domxref('PaymentAddress.dependentLocality')}} {{readonlyinline}}</dt>
 <dd>A {{domxref("DOMString")}} giving the dependent locality or sublocality within a city, for example, a neighborhood, borough, district, or UK dependent locality.</dd>
 <dt>{{domxref('PaymentAddress.organization')}} {{readonlyinline}}</dt>
 <dd>A {{domxref("DOMString")}} specifying the name of the organization, firm, company, or institution at the payment address.</dd>
 <dt>{{domxref('PaymentAddress.phone')}} {{readonlyinline}}</dt>
 <dd>A {{domxref("DOMString")}} specifying the telephone number of the recipient or contact person.</dd>
 <dt>{{domxref('PaymentAddress.postalCode')}} {{readonlyinline}}</dt>
 <dd>A {{domxref("DOMString")}} specifying a code used by a jurisdiction for mail routing, for example, the ZIP code in the United States or the PIN code in India.</dd>
 <dt>{{domxref('PaymentAddress.recipient')}} {{readonlyinline}}</dt>
 <dd>A {{domxref("DOMString")}} giving the name of the recipient, purchaser, or contact person at the payment address.</dd>
 <dt>{{domxref('PaymentAddress.region')}} {{readonlyinline}}</dt>
 <dd>A {{domxref("DOMString")}} containing the top level administrative subdivision of the country, for example a state, province, oblast, or prefecture.</dd>
 <dt>{{domxref('PaymentAddress.regionCode')}} {{readonlyinline}}</dt>
 <dd>A {{domxref("DOMString")}} specifying the region of the address, represented as a "code element" of an <a href="https://en.wikipedia.org/wiki/ISO_3166-2">ISO3166-2</a> country subdivision name (e.g. "QLD" for Queensland, Australia, "CA" for California, and so on).</dd>
 <dt>{{domxref('PaymentAddress.sortingCode')}} {{readonlyinline}}</dt>
 <dd>A {{domxref("DOMString")}} providing a postal sorting code such as is used in France.</dd>
</dl>

<div class="note">
<p><strong>Note:</strong> Properties for which values were not specified contain empty strings.</p>
</div>

<h3 id="Obsolete_properties">Obsolete properties</h3>

<p>The following properties are obsolete and should no longer be used, but may still be present in some browser versions.</p>

<dl>
 <dt>{{domxref("PaymentAddress.languageCode")}} {{ReadOnlyInline}} {{obsolete_inline}}</dt>
 <dd>A {{domxref("DOMString")}} indicating the language code of the address. This identifies the language in which the address is given, and is intended to aid in localization of the display of the address.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref('PaymentAddress.toJSON()')}}</dt>
 <dd>A standard serializer that returns a JSON representation of the <code>PaymentAddress</code> object's properties.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In the following example, the {{domxref("PaymentRequest.PaymentRequest","PaymentRequest()")}} constructor is used to create a new payment request, which takes three objects as parameters — one containing details of the payment methods that can be used for the payment, one containing details of the actual order (such as items bought and shipping options), and an optional object containing further options.</p>

<p>The first of these three (<code>supportedInstruments</code> in the example below) contains a <code>data</code> property that has to conform to the structure defined by the {{domxref("BasicCardRequest")}} dictionary.</p>

<pre class="brush:js">const supportedInstruments = [
  {
    supportedMethods: "basic-card",
  },
];

const details = {
  total: { label: "Donation", amount: { currency: "USD", value: "65.00" } },
  displayItems: [
    {
      label: "Original donation amount",
      amount: { currency: "USD", value: "65.00" },
    },
  ],
  shippingOptions: [
    {
      id: "standard",
      label: "Standard shipping",
      amount: { currency: "USD", value: "0.00" },
      selected: true,
    },
  ],
};

const options = { requestShipping: true };

async function doPaymentRequest() {
  const request = new PaymentRequest(supportedInstruments, details, options);
  // Add event listeners here.
  // Call show() to trigger the browser's payment flow.
  const response = await request.show();
  // Process payment.
  const json = response.toJSON();
  const httpResponse = await fetch("/pay/", { method: "POST", body: json });
  const result = httpResponse.ok ? "success" : "failure";

  await response.complete(result);
}
doPaymentRequest();
</pre>

<p>Once the payment flow has been triggered using {{domxref("PaymentRequest.show()")}} and the promise resolves successfully, the {{domxref("PaymentResponse")}} object available inside the fulfilled promise (<code>instrumentResponse</code> above) will have a {{domxref("PaymentResponse.details")}} property that will contain response details. This has to conform to the structure defined by the <code>BasicCardResponse</code> dictionary, and may look something like this:</p>

<pre class="brush: js">{
  "cardNumber' : '9999999999999999",
  "cardholderName' : 'Pat Straw",
  "cardSecurityCode" : "999",
  "expiryMonth" : "07",
  "expiryYear" : "2021",
  "billingAddress" : {
    "country" : "GB",
    // etc. billing address is a <a href="/en-US/docs/Web/API/PaymentAddress">PaymentAddress</a> object
  }
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Payment','#paymentaddress-interface','PaymentAddress')}}</td>
   <td>{{Spec2('Payment')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.PaymentAddress")}}</p>
</div>
